package main;

import java.io.*;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

public class CsvBuilder {

    private static String reportFile;

    public static String createTestReportFile() {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMMdd-HHmmss");
        String timestamp = LocalDateTime.now().format(formatter);
        String filePath = "src/csv/reports/test-report-" + timestamp + ".csv";

        try (BufferedWriter writer = new BufferedWriter(new FileWriter(filePath))) {
            writer.write("Role,Username,Step,Result\n"); // header
        } catch (IOException e) {
            System.err.println("Failed to create report file: " + e.getMessage());
        }

        reportFile = filePath;
        return filePath;
    }

    public static void appendTestResult(String role, String username, String step, String result) {
        if (reportFile == null) {
            System.err.println("Report file not initialized.");
            return;
        }

        try (BufferedWriter writer = new BufferedWriter(new FileWriter(reportFile, true))) {
            writer.write(String.format("%s,%s,%s,%s\n", role, username, step, result));
        } catch (IOException e) {
            System.err.println("Failed to write to report file: " + e.getMessage());
        }
    }
}
